#ifndef	_DRAW3D_H
#define	_DRAW3D_H

P3D points[MAX_VERTEXES+1];
extern int num_polys, num_tris;
extern BITMAP *TestTexture[4];
extern int tex_LUT;

void SCR_project() {
	register double	zrecip;
	register int i;
	float x,y;
	for(i=0; i<Poly::clipped_poly.num_vertexes; i++) {
		zrecip = 1.0 / (points[i].z=Poly::clipped_poly.vertex[i].getz());
		x=(h_X + V_DX*Poly::clipped_poly.vertex[i].getx()*zrecip);
		y=(h_Y - V_DY*Poly::clipped_poly.vertex[i].gety()*zrecip);
		points[i].x=(x<XRES) ? x*16 : (XRES-1)*16;
		points[i].y=(y<YRES) ? y*16 : (YRES-1)*16;
		points[i].z*=16;
	}

	// hard code in some texels because i dont know how to do it automatically
	// as you can see, this is only gona work with a quad
	points[0].u = 0.5;
	points[0].v = 0.5;
	points[1].u = TestTexture[tex_LUT]->w-0.5;
	points[1].v = 0.5;
	points[2].u = TestTexture[tex_LUT]->w-0.5;
	points[2].v = TestTexture[tex_LUT]->w-0.5;
	points[3].u = 0.5;
	points[3].v = TestTexture[tex_LUT]->w-0.5;

	points[i]=points[0]; // code depends on having first vertex repeated at end of list
}

void SCR_render()	{
	int i;

	// profiling
	num_polys++;
	num_tris+=Poly::clipped_poly.num_vertexes-2;
	// sit back awhile
	// droping below 60 FPS when
	// drawing a mind blowing   <2> yes  2 polys
	// when up close to screen is gona win me some awards

	// this is simply just a polygon triangulation routine  
	// NON 'fan' style
	// and NO HOLES please
	for(i=0; i<Poly::clipped_poly.num_vertexes-1; i+=2)
		TextureMapTri(offscreen, points+i, TestTexture[tex_LUT]);
}
#endif